# Disable debug
%define debug_package %{nil}
%define __strip /bin/true
%define buildid 8719
%define jitsi_dir jicofo-stable-jitsi-meet_%{buildid}


Name:           jicofo
Summary:        JItsi COnference FOcus is a server side focus component used in Jitsi Meet conferences. 
Version:        2.0.%{buildid}
Release:        1%{?dist}
License:        Apache 2.0
URL:            https://github.com/jitsi/jicofo
Source0:        https://github.com/jitsi/jicofo/archive/refs/tags/stable/jitsi-meet_%{buildid}.tar.gz
Source10:       config
Source12:       jicofo.conf
Source20:       jitsi-jicofo.service

BuildRequires:  maven
BuildRequires:  systemd
BuildRequires:  systemd-rpm-macros
BuildRequires:  java-11-headless
BuildRequires:  jre-11-headless
Requires:       java-11-headless
Requires:       jre-11-headless
Requires:       rubygem-hocon
Requires:       jq


%description
JItsi Meet COnference FOcus Jicofo is a conference focus for Jitsi Meet application.


%prep
%autosetup -p1 -n %{jitsi_dir}

%build
mkdir -p %{_builddir}/%{jitsi_dir}/.m2/repository

MVN="mvn -Dmaven.repo.local=%{_builddir}/%{jitsi_dir}/.m2/repository"
ls -l /usr/lib/jvm

JAVA_HOME=/usr/lib/jvm/jre-11
export JAVA_HOME
$MVN versions:set -DnewVersion="%{version}"
$MVN install
$MVN -B dependency:resolve
$MVN -DskipTests -Dassembly.skipAssembly=true package
$MVN dependency:copy-dependencies -DincludeScope=runtime


%install
install -d $RPM_BUILD_ROOT%{_datadir}/jicofo
install -d $RPM_BUILD_ROOT%{_sysconfdir}/jitsi/jicofo
install -d $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
install -d $RPM_BUILD_ROOT%{_rundir}
install -d $RPM_BUILD_ROOT%{_localstatedir}/log/jitsi
install -d $RPM_BUILD_ROOT%{_datadir}/jicofo
install -d $RPM_BUILD_ROOT%{_datadir}/jicofo/lib
install -d $RPM_BUILD_ROOT%{_unitdir}


install -p -m 640 %{SOURCE10}                           $RPM_BUILD_ROOT%{_sysconfdir}/jitsi/jicofo
install -p -m 640 %{SOURCE12}                           $RPM_BUILD_ROOT%{_sysconfdir}/jitsi/jicofo
install -p -m 644 lib/logging.properties                $RPM_BUILD_ROOT%{_sysconfdir}/jitsi/jicofo

cp -r jicofo/target/dependency/*                        $RPM_BUILD_ROOT%{_datadir}/jicofo/lib

install -p -m 644 jicofo/target/jicofo-%{version}.jar   $RPM_BUILD_ROOT%{_datadir}/jicofo/jicofo-%{version}.jar
ln -s             jicofo-%{version}.jar                 $RPM_BUILD_ROOT%{_datadir}/jicofo/jicofo.jar
install -p -m 755 resources/jicofo.sh                   $RPM_BUILD_ROOT%{_datadir}/jicofo
install -p -m 644 resources/collect-dump-logs.sh        $RPM_BUILD_ROOT%{_datadir}/jicofo
install -p -m 644 resources/config/jicofo-logrotate.d   $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/jicofo
install -p -m 644 %{SOURCE20}                           $RPM_BUILD_ROOT%{_unitdir}

%pre
getent group jitsi >/dev/null || groupadd -r jitsi
getent passwd jicofo >/dev/null || \
    useradd -r -g jitsi -d %{_datadir}/jicofo -s /sbin/nologin \
    -c "Jitsi jicofo account" jicofo
exit 0

%post
chown jicofo.jitsi %{_localstatedir}/log/jitsi
chmod 770 %{_localstatedir}/log/jitsi
ls %{_localstatedir}/log/jitsi/jicofo* 1>/dev/null 2>&1 && chown -f -R jicofo:jitsi %{_localstatedir}/log/jitsi/jicofo*
ls %{_localstatedir}/log/jitsi/jicofo* 1>/dev/null 2>&1 && chmod -f -R 640 %{_localstatedir}/log/jitsi/jicofo*

chown -R jicofo:jitsi %{_sysconfdir}/jitsi/jicofo
chown -R jicofo:jitsi %{_datadir}/jicofo

%systemd_post jitsi-jicofo.service

%preun
%systemd_preun jitsi-jicofo.service

%postun
%systemd_postun_with_restart jitsi-jicofo.service

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc README.md SECURITY.md
%{!?_licensedir:%global license %%doc}
%license LICENSE

%{_unitdir}/jitsi-jicofo.service

%dir %{_sysconfdir}/jitsi/jicofo
%config(noreplace) %{_sysconfdir}/jitsi/jicofo/*

%dir %{_localstatedir}/log/jitsi
%{_sysconfdir}/logrotate.d/jicofo
%dir %{_datadir}/jicofo
%{_datadir}/jicofo/*


%changelog
* Fri Jan 21 2022 Zoran Pericic <zpericic@infomaas.com> 2.0.6826-1
- Initial RPM release.

